/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Vivek K S

#ifndef _BASIC_WINDOW_H_
#define _BASIC_WINDOW_H_

window *new_basic_window(wm *wm, Window map_window, window_type wtype);
unsigned long window_get_state(window *win);
void window_set_state(window *win, unsigned long state);
void window_handle_focus(window *win);
window *window_get_next_mappable(window *w);
#ifdef __arm__
void window_handle_rotation(window *win);
#endif
void window_handle_keyboard(window *win);
void window_handle_annotate_icon(window *win);
void window_destroy(window *win);
void window_handle_deletion(window *w);
int window_get_int_property(window *w, atomlist_index index);
Atom window_get_atom_property(window *w, atomlist_index index);
Atom xwindow_get_atom_property(Window win, wm *wm, atomlist_index index);
int xwindow_set_text_property(wm *wm, Window win, unsigned int atomlist_index, const char *property_value);
void xwindow_get_text_property(wm *wm, Window win, unsigned int atomlist_index, unsigned char *string_ret);
void window_get_text_property(window *w, atomlist_index index, unsigned char *string_ret);
int window_set_int_property(window *w, atomlist_index index, const unsigned int property_value);
int window_set_text_property(window *w, unsigned int atomlist_index, const char *property_value);
void window_send_protocol_event(window *w, Atom protocol);
void window_send_configure_event(window *w);
void window_xmove(window *w);
void window_xresize(window *w);
window *window_find_windowid(wm *wm, Window wid);
window *window_find_appid(wm *wm, unsigned long appid);
Bool window_exists(wm *wm, window *win);

Bool window_close_callback(px_widget *widget, px_event *ev);
Bool window_up_callback(px_widget *widget, px_event *ev);
Bool window_tick_callback(px_widget *widget, px_event *ev);
Bool window_printer_callback(px_widget *widget, px_event *ev);
Bool window_email_callback(px_widget *widget, px_event *ev);
Bool window_onetap_callback(px_widget *widget, px_event *ev);
Bool window_nextpage_press_callback(px_widget *widget, px_event *ev);
Bool window_nextpage_rel_callback(px_widget *widget, px_event *ev);
Bool window_prevpage_press_callback(px_widget *widget, px_event *ev);
Bool window_prevpage_rel_callback(px_widget *widget, px_event *ev);
Bool window_help_callback(px_widget *widget, px_event *ev);
Bool window_pref_callback(px_widget *widget, px_event *ev);
Bool window_retractbar_callback(px_widget *widget, px_event *ev);
Bool window_nextapp_callback(px_widget *widget, px_event *ev);
Bool window_prevapp_callback(px_widget *widget, px_event *ev);
Bool window_home_callback(px_widget *widget, px_event *ev);
Bool window_annotate_callback(px_widget *widget, px_event *ev);
Bool window_keyboard_callback(px_widget *widget, px_event *ev);
Bool window_keyboard_chooser_callback(px_widget *widget, px_event *ev);
Bool window_star_callback(px_widget *widget, px_event *ev);
Bool window_status_callback(px_widget *widget, px_event *ev);
Bool window_title_callback(px_widget *widget, px_event *ev);
Bool window_speaker_callback(px_widget *widget, px_event *ev);
Bool window_voice_callback(px_widget *widget, px_event *ev);
Bool window_xstroke_callback(px_widget *widget, px_event *ev);
char *window_get_annotation_prefix(window *win, Bool escaped);
void window_launch_annotate(window *win);
void xstroke_start_reconition(wm *wm);
void xstroke_stop_recognition(wm *wm);
#endif
